// TrackerPod.h: interface for the CTrackerPod class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TRACKERPOD_H__99719B3B_6E27_4935_9030_6E22B253260E__INCLUDED_)
#define AFX_TRACKERPOD_H__99719B3B_6E27_4935_9030_6E22B253260E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


typedef void (__stdcall *_dev_change_notify)(int devindex, char *version, int status, unsigned long user_data);

class CTrackerPod
{
public:
	CTrackerPod() { }
	virtual ~CTrackerPod() { }
	virtual bool initialize(char *client_id, 
				_dev_change_notify pfn,
				unsigned long user_data,
				bool b_show_on_event)				= 0;

	virtual bool begin_enum_device()				= 0;
	virtual bool enum_reset()						= 0;
	virtual long enum_next(char *ver)				= 0;

	virtual bool use_device(long devid)				= 0;
	virtual bool move_to(float x, float y)			= 0;
	virtual bool move_by(float x, float y)			= 0;
	virtual long control(char cmd[1024])			= 0;

	virtual bool get_pos(float *x, float *y)		= 0;
	virtual bool get_info(char info[1024])			= 0;

	virtual void show_on_event(bool show)			= 0;
	virtual void show_manager(bool show)			= 0;
	virtual bool is_manager_visible()				= 0;

	virtual void ReleaseTrackerPod()				= 0;
	static CTrackerPod* CreateTrackerPod();
};

#endif // !defined(AFX_TRACKERPOD_H__99719B3B_6E27_4935_9030_6E22B253260E__INCLUDED_)
