// WINTPOD.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "resource.h"
#include <windowsx.h>
#include <objbase.h>
#include <stdio.h>
#include "TrackerPod.h"

#pragma comment(lib, "trackerpod_mt.lib")


#define WM_DEV_CHANGE_NOTIFY WM_USER + 0x100

CTrackerPod *g_pTrackerPod = NULL;
HWND g_hwnd = NULL;

int g_index = -1;
char g_version[16];
int g_status = 0;
unsigned long g_user_data = 0;

void __stdcall devchg_callback(int index, char *ver, int status, unsigned long user_data)
{
	if(g_hwnd)
	{
		g_index = index;
		strcpy(g_version, ver);
		g_status = status;
		g_user_data = user_data;
		PostMessage(g_hwnd, WM_DEV_CHANGE_NOTIFY, 0, NULL);
	}
}

int g_xPos, g_yPos; 
HINSTANCE	g_hInstance = NULL;

BOOL CALLBACK DialogProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	PAINTSTRUCT ps;
	HDC hdc;
	switch (msg)
	{
	case WM_DEV_CHANGE_NOTIFY:
		{
			char szHello[255];
			sprintf(szHello, "index: %d status: %d ver: %s  user_data: %d", g_index, g_status, g_version, g_user_data);
			SetWindowText(hwnd, szHello);

			BOOL bEnable = FALSE;
			if(g_status != 0)
				bEnable = TRUE;

			EnableWindow(GetDlgItem(hwnd, IDC_BUTTON_LEFT), bEnable);
			EnableWindow(GetDlgItem(hwnd, IDC_BUTTON_RIGHT), bEnable);
			EnableWindow(GetDlgItem(hwnd, IDC_BUTTON_UP), bEnable);
			EnableWindow(GetDlgItem(hwnd, IDC_BUTTON_DOWN), bEnable);
			EnableWindow(GetDlgItem(hwnd, IDC_BUTTON_HOME), bEnable);

			EnableWindow(GetDlgItem(hwnd, IDC_BUTTON_GET_POS), bEnable);
			EnableWindow(GetDlgItem(hwnd, IDC_STATIC_POS), bEnable);

			EnableWindow(GetDlgItem(hwnd, IDC_COMBO_CONTROL), bEnable);
			break;
		}

	case WM_COMMAND:

		if(LOWORD (wParam) == IDC_BUTTON_MOVE_EXT)
		{
			char move_ext_cmd[1024];
			GetDlgItemText(hwnd, IDC_EDIT_MOVE_EXT, move_ext_cmd, sizeof(move_ext_cmd) - 1);
			if(move_ext_cmd[0] == '\0')
			{
				MessageBox(hwnd, "Please type in valid string", "wintpod", MB_OK);
				break;
			}

			g_pTrackerPod->control(move_ext_cmd);

		}
//	-------------------------------------------------------------------------------------
//	-------------------------------------------------------------------------------------
		if(LOWORD (wParam) == IDC_SEND_ZOOM2)
		{

			char szValue[256];
			GetDlgItemText(hwnd, IDC_EDIT_ZOOM2, szValue, sizeof(szValue) - 1);
			if(szValue[0] == '\0')
				break;

			int val = atol(szValue);

			if(val < 100)
				val = 100;

			if(val > 26000)
				val = 26000;

			sprintf(szValue, "%d", val);
			char move_ext_cmd[1024];
			sprintf(move_ext_cmd, "optical_zoom=%s", szValue);
			g_pTrackerPod->control(move_ext_cmd);

			SetDlgItemText(hwnd, IDC_EDIT_ZOOM2, szValue);
		}

		if(LOWORD (wParam) == IDC_SEND_ZOOM_INC2)
		{
			char szValue[256];
			GetDlgItemText(hwnd, IDC_EDIT_ZOOM2, szValue, sizeof(szValue) - 1);
			if(szValue[0] == '\0')
				break;

			int val = atol(szValue);
			val += 1;

			if(val > 26000)
				val = 26000;

			char move_ext_cmd[1024];
			sprintf(move_ext_cmd, "optical_zoom=%d", val);
			g_pTrackerPod->control(move_ext_cmd);

			sprintf(szValue, "%d", val);
			SetDlgItemText(hwnd, IDC_EDIT_ZOOM2, szValue);
		}

		if(LOWORD (wParam) == IDC_SEND_ZOOM_DEC2)
		{
			char szValue[256];
			GetDlgItemText(hwnd, IDC_EDIT_ZOOM2, szValue, sizeof(szValue) - 1);
			if(szValue[0] == '\0')
				break;

			int val = atol(szValue);
			val -= 1;

			if(val < 100)
				val = 100;

			char move_ext_cmd[1024];
			sprintf(move_ext_cmd, "optical_zoom=%d", val);
			g_pTrackerPod->control(move_ext_cmd);

			sprintf(szValue, "%d", val);
			SetDlgItemText(hwnd, IDC_EDIT_ZOOM2, szValue);
		}

		if(LOWORD (wParam) == IDC_SEND_ZOOM3)
		{
			char szValue[256];
			GetDlgItemText(hwnd, IDC_EDIT_ZOOM3, szValue, sizeof(szValue) - 1);
			if(szValue[0] == '\0')
				break;

			int val = atol(szValue);

			if(val < 0)	val = 0;
			if(val > 6)	val = 6;

			char move_ext_cmd[1024];
			sprintf(move_ext_cmd, "LANC_zoom_speed=%d", val);
			g_pTrackerPod->control(move_ext_cmd);
		}


//	-------------------------------------------------------------------------------------
		if(LOWORD (wParam) == IDOK)
		{
			EndDialog(hwnd, TRUE);
			break;
		}

		if(LOWORD (wParam) == IDC_BUTTON_INITIALIZE)
		{
			char client_id[100];
			GetDlgItemText(hwnd, IDC_EDIT_CLIENT_ID, client_id, sizeof(client_id) - 1);

			if(client_id[0] == '\0')
			{
				MessageBox(hwnd, "Please type in client ID", "wintpod", MB_OK);
				break;
			}
 
			if(g_pTrackerPod->initialize(client_id, devchg_callback, 1234, false))
			{
				HWND but_init = GetDlgItem(hwnd, IDC_BUTTON_INITIALIZE);
				HWND edt_clid = GetDlgItem(hwnd, IDC_EDIT_CLIENT_ID);
				EnableWindow(but_init, FALSE);
				EnableWindow(edt_clid, FALSE);
			}
			else
				MessageBox(hwnd, "Failed to initialize!", "wintpod", MB_OK);
			break;
		}

		if(LOWORD (wParam) == IDC_BUTTON_GET_POS)
		{
			float x, y;
			if(g_pTrackerPod->get_pos(&x, &y))
			{
				HWND hwnd_pos = GetDlgItem(hwnd, IDC_STATIC_POS);
				char szHello[256];
				sprintf(szHello, "%5.2f %5.2f", x, y);
				SetWindowText(hwnd_pos, szHello);
			}

			break;
		}

		if(LOWORD (wParam) == IDC_BUTTON_GETINFO)
		{
			char info[1024];
			if(g_pTrackerPod->get_info(info))
				SetDlgItemText(hwnd, IDC_EDIT_INFO, info);
			else
				SetDlgItemText(hwnd, IDC_EDIT_INFO, "cannot get info");
			break;
		}

		if(LOWORD (wParam) == IDC_BUTTON_LEFT)
		{
			g_pTrackerPod->move_by(+1.0, 0.0);
			break;
		}

		if(LOWORD (wParam) == IDC_BUTTON_RIGHT)
		{
			g_pTrackerPod->move_by(-1.0, 0.0);
			break;
		}


		if(LOWORD (wParam) == IDC_BUTTON_UP)
		{
			g_pTrackerPod->move_by(0.0, -1.0);
			break;
		}

		if(LOWORD (wParam) == IDC_BUTTON_DOWN)
		{
			g_pTrackerPod->move_by(0.0, 1.0);
			break;
		}

		if(LOWORD (wParam) == IDC_BUTTON_HOME)
		{
			g_pTrackerPod->move_to(0.0, 0.0);
			break;
		}

		if(LOWORD (wParam) == IDC_BUTTON_GETDEVLIST)
		{
			HWND hwnd_devlist = GetDlgItem(hwnd, IDC_COMBO_DEVPATH_LIST);
			int count = ComboBox_GetCount(hwnd_devlist);
			for(int i = 0; i < count; ++i)
			{
				char *pData = (char *)ComboBox_GetItemData(hwnd_devlist, i);
				delete pData;
			}

			ComboBox_ResetContent(hwnd_devlist);

			int index = ComboBox_AddString(hwnd_devlist, "do not use trackerpod");
			ComboBox_SetItemData(hwnd_devlist, index, NULL);

			if(g_pTrackerPod->begin_enum_device())
			{
				while(true)
				{
					int devid = g_pTrackerPod->enum_next(0);
					if(devid < 0)
						break;

					char devname[256];
					sprintf(devname, "Plug_%d", devid);
					index = ComboBox_AddString(hwnd_devlist, devname);

					int *pData = new int;
					*pData = devid;
					ComboBox_SetItemData(hwnd_devlist, index, pData);
				}
			}
			ComboBox_SetCurSel(hwnd_devlist, 0);
			break;
		}

		if(LOWORD (wParam) == IDC_SHOW_MANAGER)
		{
			if(g_pTrackerPod->is_manager_visible())
				g_pTrackerPod->show_manager(false);
			else
				g_pTrackerPod->show_manager(true);
		}	

		if(HIWORD (wParam) == CBN_SELCHANGE)
		{
			if(GetDlgCtrlID((HWND)lParam) == IDC_COMBO_DEVPATH_LIST)
			{
				DWORD cursel = ComboBox_GetCurSel((HWND)lParam);
				int *devid = (int *)ComboBox_GetItemData((HWND)lParam, cursel);
				if(devid)
					g_pTrackerPod->use_device(*devid);
				else
					g_pTrackerPod->use_device(-1);
			}

			if(GetDlgCtrlID((HWND)lParam) == IDC_COMBO_CONTROL)
			{
				DWORD cursel = ComboBox_GetCurSel((HWND)lParam);
				char ctrl_text[256];
				ComboBox_GetLBText((HWND)lParam, cursel, ctrl_text);
				long ret = g_pTrackerPod->control(ctrl_text);
				char result[256];
				sprintf(result, "%s : %d", ctrl_text, ret);
				SetDlgItemText(hwnd, IDC_STATIC_CONTROL, result);
			}

			break;
		}

		return TRUE;

	case WM_INITDIALOG:
		{
			g_hwnd = hwnd;

			HWND hwnd_control = GetDlgItem(hwnd, IDC_COMBO_CONTROL);

			ComboBox_AddString(hwnd_control, "led=on");
			ComboBox_AddString(hwnd_control, "led=off");

			ComboBox_AddString(hwnd_control, "buffering=on");
			ComboBox_AddString(hwnd_control, "buffering=off");
			ComboBox_AddString(hwnd_control, "flushbuffer");

			ComboBox_AddString(hwnd_control, "pan_tilt_step_size=1");
			ComboBox_AddString(hwnd_control, "pan_tilt_step_size=2");
			ComboBox_AddString(hwnd_control, "pan_tilt_step_size=3");
			ComboBox_AddString(hwnd_control, "pan_tilt_step_size=4");
			ComboBox_AddString(hwnd_control, "pan_tilt_step_size=5");

			ComboBox_AddString(hwnd_control, "zoom=in");
			ComboBox_AddString(hwnd_control, "zoom=out");
			ComboBox_AddString(hwnd_control, "zoom=home");

			ComboBox_AddString(hwnd_control, "focus=far");
			ComboBox_AddString(hwnd_control, "focus=near");

			ComboBox_AddString(hwnd_control, "zoom_step_size=1");
			ComboBox_AddString(hwnd_control, "zoom_step_size=2");
			ComboBox_AddString(hwnd_control, "zoom_step_size=3");
			ComboBox_AddString(hwnd_control, "zoom_step_size=4");
			ComboBox_AddString(hwnd_control, "zoom_step_size=5");
			ComboBox_AddString(hwnd_control, "zoom_step_size=6");
			ComboBox_AddString(hwnd_control, "zoom_step_size=7");
			ComboBox_AddString(hwnd_control, "zoom_step_size=8");
			ComboBox_AddString(hwnd_control, "zoom_step_size=9");
			ComboBox_AddString(hwnd_control, "zoom_step_size=10");

			ComboBox_AddString(hwnd_control, "auto_focus=on");
			ComboBox_AddString(hwnd_control, "auto_focus=off");

			ComboBox_AddString(hwnd_control, "digital_zoom=on");
			ComboBox_AddString(hwnd_control, "digital_zoom=off");

			ComboBox_AddString(hwnd_control, "LANC_toggle_auto_focus");
			ComboBox_AddString(hwnd_control, "LANC_toggle_record");

			ComboBox_SetCurSel(hwnd_control, 0);
		}
		return TRUE;
	case WM_PAINT:
		hdc = BeginPaint(hwnd, &ps);
		EndPaint(hwnd, &ps);
		return 0;
	case WM_SIZE:
		return TRUE;
	case WM_CLOSE:
		{
			HWND hwnd_devlist = GetDlgItem(hwnd, IDC_COMBO_DEVPATH_LIST);
			int count = ComboBox_GetCount(hwnd_devlist);
			for(int i = 0; i < count; ++i)
			{
			char *pData = (char *)ComboBox_GetItemData(hwnd_devlist, i);
				delete pData;
			}
			ComboBox_ResetContent(hwnd_devlist);
			EndDialog(hwnd, TRUE);
		}

	case WM_LBUTTONDOWN:
		{
			g_xPos = GET_X_LPARAM(lParam); 
			g_yPos = GET_Y_LPARAM(lParam); 
			SetCapture(hwnd);
			break;
		}

	case WM_LBUTTONUP:
		{
			ReleaseCapture();
			break;
		}
	case WM_MOUSEMOVE:
		{
			if(wParam == MK_LBUTTON)
			{
				int xPos = GET_X_LPARAM(lParam); 
				int yPos = GET_Y_LPARAM(lParam);
				int dx = xPos - g_xPos;
				int dy = yPos - g_yPos;
				g_pTrackerPod->move_by(-dx /2.0, dy/2.0);
				g_xPos = xPos;
				g_yPos = yPos;
			}

			break;
		}
	}
	return FALSE;
}

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
 	// TODO: Place code here.

	g_pTrackerPod = CTrackerPod::CreateTrackerPod();
	if(!g_pTrackerPod)
		return 0;

	g_hInstance = hInstance;
	DialogBox(g_hInstance, MAKEINTRESOURCE(IDD_TRACKERPOD_TEST), NULL, (DLGPROC)DialogProc);

	if(g_pTrackerPod)
		g_pTrackerPod->ReleaseTrackerPod();
	g_pTrackerPod = NULL;

	return 0;
}

